import * as Raven from 'raven-js';


quayConfig.$inject = [
  '$provide',
  '$injector',
  'INJECTED_CONFIG',
  'cfpLoadingBarProvider',
  '$tooltipProvider',
  '$compileProvider',
  'RestangularProvider',
];

export function quayConfig(
  $provide: ng.auto.IProvideService,
  $injector: ng.auto.IInjectorService,
  INJECTED_CONFIG: any,
  cfpLoadingBarProvider: any,
  $tooltipProvider: any,
  $compileProvider: ng.ICompileProvider,
  RestangularProvider: any) {
  cfpLoadingBarProvider.includeSpinner = false;

  // decorate the tooltip getter
  var tooltipFactory: any = $tooltipProvider.$get[$tooltipProvider.$get.length - 1];
  $tooltipProvider.$get[$tooltipProvider.$get.length - 1] = function($window: ng.IWindowService) {
    if ('ontouchstart' in $window) {
      var existing: any = tooltipFactory.apply(this, arguments);
      return function(element) {
        // Note: We only disable bs-tooltip's themselves. $tooltip is used for other things
        // (such as the datepicker), so we need to be specific when canceling it.
        if (element !== undefined && element.attr('bs-tooltip') == null) {
          return existing.apply(this, arguments);
        }
      };
    }

    return tooltipFactory.apply(this, arguments);
  };

  if (!INJECTED_CONFIG['DEBUG']) {
    $compileProvider.debugInfoEnabled(false);
  }

  // Configure compile provider to add additional URL prefixes to the sanitization list. We use
  // these on the Contact page.
  $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|tel|irc):/);

  // Configure the API provider.
  RestangularProvider.setBaseUrl('/api/v1/');

  // Configure analytics.
  if (INJECTED_CONFIG && INJECTED_CONFIG.MIXPANEL_KEY) {
    let $analyticsProvider: any = $injector.get('$analyticsProvider');
    $analyticsProvider.virtualPageviews(true);
  }

  // Configure sentry.
  if (INJECTED_CONFIG && INJECTED_CONFIG.SENTRY_PUBLIC_DSN) {
    $provide.decorator("$exceptionHandler", function($delegate) {
      return function(ex, cause) {
        $delegate(ex, cause);
        Raven.captureException(ex, {extra: {cause: cause}});
      };
    });
  }
}
